#![allow(dead_code)]

mod tag;
mod util;
mod runtime;
mod interface; pub use interface::*;

const SCH_MAGAZINE :usize = 0x110;
const SCH_MAGAZINE_ROW :usize = 0x111;

pub fn test() {
    Schema::with(vec![
        ("type", natural()),
        ("quantity", natural()),
    ]).bind(SCH_MAGAZINE_ROW);
    Schema::with(vec![
        ("size", natural()),
        ("content", list(record(SCH_MAGAZINE_ROW))),
    ]).bind(SCH_MAGAZINE);

    let mag = Record::with(SCH_MAGAZINE, vec![
        ("size", *Natural::with(30)),
    ]).unwrap();
    let mut contents = List::from(mag.get("content")).unwrap();
    contents.append(*Record::with_values(SCH_MAGAZINE_ROW, vec![
        *Natural::with(2),
        *Natural::with(5),
    ]).unwrap());
    contents.append(*Record::with_values(SCH_MAGAZINE_ROW, vec![
        *Natural::with(1),
        *Natural::with(25),
    ]).unwrap());

    {
        // get and remove bullet
        let mut list = List::from(mag.at(1)).unwrap();
        if list.length() > 0 {
            let row = Record::from(list.at(list.length() - 1)).unwrap();
            let mut cell = Natural::from(row.at(1)).unwrap();
            let value = cell.get();
            if value > 1 {
                cell.set(value - 1);
            } else {
                list.remove(list.length() - 1);
            }
        }
    }

    println!("Magazine ({})",
        Natural::from(mag.at(0)).unwrap().get(),
    );
    for i in 0..contents.length() {
        let row = Record::from(contents.at(i)).unwrap();
        println!(" - {} [{}]",
            Natural::from(row.at(0)).unwrap().get(),
            Natural::from(row.at(1)).unwrap().get(),
        );
    }
}

#[cfg(test)]
mod tests;
